#include <iostream>
#include<vector>
#include<set>
#include<stack>
#include<utility>
void solve(std::vector<std::vector<std::pair<int, bool>>>& cities, std::set<int>& distances, int k) {
    int start = 1, end = cities.size() - 2, current = 0;
    int takenPlanes = 0;
    int currentVehicles = 0;
    std::stack<int>s;
    for (int i = start; i <= end; i++) {
        s.push(i + 1);
        while (!s.empty()) {
            current = s.top();
            s.pop();
            if (current == end) {
                distances.insert(currentVehicles);
                currentVehicles--;
                continue;
            }
            if (cities[current][i].first != 0 && !cities[current][i].second) {
                if (cities[current][i].first == 2) {
                    if (takenPlanes == k)
                        continue;
                    takenPlanes++;
                }
                currentVehicles++;
                cities[current][i].second = true;
                s.push(cities[current][i].first);
            }
        }
    }
}

int main()
{
    int n = 0, m = 0, k = 0;
    std::cin >> n >> m >> k;
    std::vector<std::vector<std::pair<int,bool>>>cities(n+2, std::vector<std::pair<int, bool>>(n+2,std::pair<int,bool>(0,false)));
    int a = 0, b = 0, t = 0;
    for (int i = 0; i < m; i++) {
        std::cin >> a >> b >> t;
        cities[a][b].first = t;
        cities[b][a].first = t;
    }
    std::set<int>distances;
    solve(cities, distances, k);
    if (!distances.empty()) {
        const auto it = distances.rbegin();
        std::cout << *it << '\n';
    }
    else {
        std::cout << -1 << '\n';
    }
    return 0;
}