#include<vector>
#include<cmath>
#include"segment.h"


long long gcd(int a, int b) {
	if (a < b) {
		std::swap(a, b);
	}
	int c = 0;
	while (b != 0) {
		c = a % b;
		a = b;
		b = c;
	}
	return a;
}
bool areAllPrime(const std::vector<int>& A) {
	int srt = 0;
	for (int i = 0; i < A.size(); i++) {
		if (A[i] == 1)
			return false;
		srt = sqrt(A[i]);
		for (int j = 2; j<srt; i++) {
			if (A[i] % j == 0)
				return false;
		}
	}
	return true;
}

int findLongestSubSeq(const std::vector<int>& A, int& el,int& max) {
	max = A[0];
	el = A[0];
	int currEl = A[0];
	int currL = 1,longestL=1;
	for (int i = 1; i < A.size(); i++) {
		if (max < A[i]) {
			max = A[i];
		}
		if (currEl == A[i]) {
			currL++;
			continue;
		}
		if (currEl != A[i]) {
			if (longestL < currL && el < currEl) {
				longestL = currL;
				el = currEl;
			}
			currL = 1;
			currEl = A[i];
		}
	}
	if (currL == A[A.size()-1]) {
		longestL++;
	}
	if (longestL < currL && el < currEl) {
		longestL = currL;
		el = currEl;
	}
	return longestL;
}

long long primeSol(const std::vector<int>& A) {
	int el = 0, max = 0;
	int l = findLongestSubSeq(A, el, max);
	int res = el * l;
	if (res < max) {
		res = max;
	}
	if (res < A.size()) {
		res = A.size();
	}
	return res;
}

long long max_segment(std::vector<int> A) {

	int size = A.size();
	if (areAllPrime(A)) {
		return primeSol(A);
	}
	int currentgcd = 0;
	long long result = size;
	long long val = 0;
	bool shouldBreak = false;
	for (int i = 0; i < size; i++) {
		shouldBreak = false;
		for (int r = i; r < size; r++) {
			currentgcd = A[i];
			if (result < A[i]) {
				result = A[i];
			}
			for (int l = i + 1; l <= r; l++) {
				currentgcd = gcd(currentgcd, A[l]);
				if (currentgcd == 1) {
					shouldBreak = true;
					break;
				}
				val = ((l + 1) - (i + 1) + 1) * currentgcd;
				if (result < val) {
					result = val;
				}
			}
			if (shouldBreak)
				break;
		}
	}
	return result;
}
