#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int INF = 1e9;

int dist[MAXN + 5][2];
vector<int> G[MAXN + 5];

void BFS(int u, int t)
{
    queue<int> q;
    q.push(u);
    dist[u][t] = 0;
    while (!q.empty())
    {
        u = q.front();
        q.pop();
        for (auto v : G[u])
        {
            if (dist[v][t] == INF)
            {
                dist[v][t] = dist[u][t] + 1;
                q.push(v);
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, k;
    cin >> n >> m >> k;

    vector< pair<int, int> > e;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        if (t == 1)
        {
            G[u].push_back(v);
            G[v].push_back(u);
        }
        else e.push_back({u, v});
    }

    for (int i = 1; i <= n; ++ i)
    {
        dist[i][0] = dist[i][1] = INF;
    }

    BFS(1, 0);
    int ans = dist[n][0];
    BFS(n, 1);

    for (auto [u, v] : e)
    {
        ans = min(ans, dist[u][0] + dist[v][1] + 1);
        ans = min(ans, dist[v][0] + dist[u][1] + 1);
    }
    if (ans == INF) ans = -1;
    cout << ans << endl;

    return 0;
}
