#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int INF = 1e9;

int n, m, k;
int dist[MAXN + 5][3];
vector<int> G[MAXN + 5][2];

void BFS(int u)
{
    queue< pair<int, int> > q;
    q.push({u, 0});
    dist[u][0] = 0;
    while (!q.empty())
    {
        u = q.front().first;
        int t = q.front().second;
        q.pop();
        for (auto v : G[u][0])
        {
            if (dist[v][t] == INF)
            {
                dist[v][t] = dist[u][t] + 1;
                q.push({v, t});
            }
        }
        if (t == k) continue;
        for (auto v : G[u][1])
        {
            if (dist[v][t + 1] == INF)
            {
                dist[v][t + 1] = dist[u][t] + 1;
                q.push({v, t + 1});
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> k;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u][t - 1].push_back(v);
        G[v][t - 1].push_back(u);
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j <= k; ++ j)
        {
            dist[i][j] = INF;
        }
    }

    BFS(1);

    int ans = INF;
    for (int j = 0; j <= k; ++ j)
    {
        ans = min(ans, dist[n][j]);
    }
    if (ans == INF) ans = -1;
    cout << ans << endl;

    return 0;
}
