#include "segment.h"
#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 3000000;

int n;
int a[MAXN + 5];
int opt[MAXN + 5];
int tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = __gcd(tree[2 * v], tree[2 * v + 1]);
}

int query(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return __gcd(query(2 * v, l, mid, ql, qr), query(2 * v + 1, mid + 1, r, ql, qr));
}

long long max_segment(vector<int> A)
{
    n = A.size();
    for (int i = 0; i < n; ++ i)
    {
        a[i + 1] = A[i];
    }
    build(1, 1, n);

    long long ans = 1ll * n * query(1, 1, n, 1, n);
    for (int i = 1; i <= n; ++ i)
    {
        long long j = i;
        if (__gcd(a[i], a[i - 1]) > 1) j = max(i, opt[i - 1]);
        long long g = query(1, 1, n, i, j);
        while (true)
        {
            while (j < n and 1ll * (j - i + 1) * g < ans)
            {
                j = i + (ans - 1) / g;
                if (j > n) break;
                g = query(1, 1, n, i, j);
            }
            if (j > n) break;
            int l = j, r = n + 1, mid;
            while (r - l > 1)
            {
                mid = (l + r) / 2;
                if (query(1, 1, n, i, mid) == g) l = mid;
                else r = mid;
            }
            j = l;
            ans = max(ans, 1ll * (j - i + 1) * g);
            opt[i] = j;
            j++;
            if (j > n) break;
            g = __gcd(g, 1ll * a[j]);
        }
    }
    return ans;
}
