#include "segment.h"
#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 3000000;

int n;
long long ans;
int a[MAXN + 5];
bool e[MAXN + 5];
vector<int> primes;
int le[MAXN + 5], lediv[MAXN + 5];

void eratosthenes()
{
    e[1] = true;
    for (int i = 2; i <= n; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= n; j += i)
            {
                e[j] = true;
            }
        }
    }
}

bool go(int div)
{
    bool flag = false;
    for (int i = 1; i <= n; ++ i)
    {
        if (a[i] % div) le[i] = lediv[i] = -1;
        else
        {
            le[i] = i;
            lediv[i] = a[i];
            if (i > 1 and __gcd(a[i], lediv[i - 1]) >= div)
            {
                le[i] = le[i - 1];
                lediv[i] = __gcd(a[i], lediv[i - 1]);
            }
            if (1ll * (i - le[i] + 1) * lediv[i] > ans)
            {
                ans = 1ll * (i - le[i] + 1) * lediv[i];
                flag = true;
            }
        }
    }
    return flag;
}

long long max_segment(vector<int> A)
{
    n = A.size();
    int mx = 0, g = 0;
    for (int i = 1; i <= n; ++ i)
    {
        a[i] = A[i - 1];
        mx = max(mx, a[i]);
        g = __gcd(g, a[i]);
    }

    eratosthenes();

    ans = 1ll * n * g;
    for (auto p : primes)
    {
        long long num = p;
        while (num <= mx and go(num)) num *= p;
    }
    return ans;
}
