#include "segment.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 3000000;

int n;
int a[MAXN + 5];
int tree[4 * MAXN + 5];
vector<int> active, tmp;

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = __gcd(tree[2 * v], tree[2 * v + 1]);
}

int query(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return __gcd(query(2 * v, l, mid, ql, qr), query(2 * v + 1, mid + 1, r, ql, qr));
}

long long max_segment(vector<int> A)
{
    n = A.size();
    for (int i = 0; i < n; ++ i)
    {
        a[i + 1] = A[i];
    }
    build(1, 1, n);

    long long ans = 1ll * n * query(1, 1, n, 1, n);
    for (int i = n; i >= 1; -- i)
    {
        ans = max(ans, 1ll * (n - i + 1) * query(1, 1, n, i, n));
        if (i == n) continue;

        tmp.clear();
        if (__gcd(a[i], a[i + 1]) != a[i]) tmp.push_back(i + 1);

        if (active.size() + tmp.size() == 0) continue;

        int ptr = 0;
        if (tmp.size() == 0)
        {
            tmp.push_back(active[0]);
            ptr = 1;
        }

        int pos = tmp.back();
        int g = query(1, 1, n, i, pos), g0 = a[i];
        while (true)
        {
            ans = max(ans, 1ll * (pos - i) * g0);
            if (ptr == active.size()) break;
            int g2 = query(1, 1, n, i, active[ptr]);
            if (g != g2)
            {
                pos = active[ptr];
                tmp.push_back(active[ptr]);
                g0 = g;
                g = g2;
            }
            ptr++;
        }
        active = tmp;
    }
    return ans;
}
