#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

mt19937 rg(5139014123);

const int MAXN = 100000;
const int MAXK = 100;

int last;
int n, m, d, k;
int c[MAXN + 5];
int cnt[MAXK + 5];
vector<int> G[MAXN + 5];

bool check()
{
    for (int u = last; u <= n; ++ u)
    {
        for (int i = 1; i <= k; ++ i)
        {
            cnt[i] = 0;
        }

        for (auto v : G[u])
        {
            cnt[c[v]]++;
        }

        int mn = 1;
        for (int i = 2; i <= k; ++ i)
        {
            if (cnt[i] < cnt[mn]) mn = i;
        }

        if (cnt[mn] < cnt[c[u]])
        {
            c[u] = mn;
            last = u + 1;
            return true;
        }
    }
    return false;
}

void solve()
{
    cin >> n >> m >> d >> k;

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
    }

    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= n; ++ i)
    {
        c[i] = rg() % k + 1;
    }

    last = 1;
    while (check());

    for (int i = 1; i <= n; ++ i)
    {
        cout << c[i] << " ";
    }
    cout << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
