#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF = 1e9;

int n, m, k;
int a[MAXN];
int dist[MAXN][3];
bool vis[MAXN][3];
std::vector <std::pair <int,int>> g[MAXN];

struct PQelement
{
    int node;
    int planes;
    int dist;

    friend bool operator < (const PQelement &a, const PQelement &b)
    {
        return a.dist > b.dist;
    }
};

std::priority_queue <PQelement> pq;
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        dist[i][0] = dist[i][1] = dist[i][2] = INF;
    }

    dist[1][0] = 0;
    pq.push({1, 0, 0});

    while (pq.size())
    {
        auto [node, planes, mYDist] = pq.top();
        pq.pop();

        if (vis[node][planes])
        {
            continue;
        }

        vis[node][planes] = true;
        for (const auto &[u, t] : g[node])
        {
            int nextPlanes = planes + (t == 2);
            if (nextPlanes <= k && dist[u][nextPlanes]  > dist[node][planes] + 1)
            {
                dist[u][nextPlanes] = dist[node][planes] + 1;
                pq.push({u, nextPlanes, dist[u][nextPlanes]});
            }
        }
    }

    int min = INF;
    for (int i = 0 ; i <= k ; ++i)
    {
        min = std::min(min, dist[n][i]);
    }

    if (min == INF) std::cout << -1 << '\n';
    else std::cout << min << '\n';
}

void input()
{
    std::cin >> n >> m >> k;
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v, t;
        std::cin >> u >> v >> t;
        g[u].push_back({v, t});
        g[v].push_back({u, t});
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
