#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 3000000 + 10;
const int INF = 1e9;

int n;
int a[MAXN];
llong answer;
std::pair <int,int> left[35];
std::pair <int,int> right[35];

void divide(int l, int r)
{
    if (l == r)
    {
        answer = std::max(answer, 1LL * a[l]);
        return;
    }

    int mid = (l + r) / 2;
    divide(l, mid); divide(mid + 1, r);

    //std::vector <std::pair <int,int>> left;
    //std::vector <std::pair <int,int>> right;

    int leftPtr = 0;
    int rightPtr = 0;
    int gcd = 0;
    for (int ptr = mid ; ptr >= l ; --ptr)
    {
        int newGcd = std::__gcd(gcd, a[ptr]);
        if (newGcd != gcd && gcd > 0)
        {
            left[leftPtr++] = {gcd, mid - ptr};
        }

        gcd = newGcd;
    }

    left[leftPtr++] = {gcd, mid - l + 1};
    gcd = 0;

    for (int ptr = mid + 1 ; ptr <= r ; ++ptr)
    {
        int newGcd = std::__gcd(gcd, a[ptr]);
        if (newGcd != gcd && gcd > 0)
        {
            right[rightPtr++] = {gcd, ptr - mid - 1};
        }

        gcd = newGcd;
    }

    int curr;
    right[rightPtr++] = {gcd, r - mid};
    for (int idxL = 0 ; idxL < leftPtr ; ++idxL)
    {
        const auto &[gcdL, lenL] = left[idxL];
        if (1LL * gcdL * (r - l) < answer)
        {
            break;
        }

        for (int idxR = 0 ; idxR < rightPtr ; ++idxR)
        {
            const auto &[gcdR, lenR] = right[idxR];
            curr = std::__gcd(gcdL, gcdR);
            answer = std::max(answer, 1LL * (lenL + lenR) * curr);
            if (1LL * curr * (lenL + r - mid) <= answer)
            {
                break;
            }
        }
    }
}

llong max_segment(std::vector <int> A)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    divide(1, n);
    return answer;
}
