#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <queue>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF = 1e9;

int n, m, d, k;
std::vector <int> g[MAXN];
std::mt19937 rng(69420);
int col[MAXN];

bool check()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        int cnt = 0;
        for (const int &u : g[i])
        {
            cnt += (col[u] == col[i]);
            if (cnt > d / k) return false;
        }
    }

    return true;
}

void solve()
{
    do
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            col[i] = rng() % k + 1;
        }
    } while (!check());

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << col[i] << ' ';
    }

    std::cout << '\n';
}

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        g[i].clear();
    }
}

void input()
{
    std::cin >> n >> m >> d >> k;
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIOI();
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        solve();
    }

    return 0;
}
