#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <queue>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MAXK = 100 + 10;
const int INF = 1e9;

int n, m, d, k;
std::vector <int> g[MAXN];
std::mt19937 rng(69420);
int col[MAXN];

bool check()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        int cnt = 0;
        for (const int &u : g[i])
        {
            cnt += (col[u] == col[i]);
            if (cnt > d / k) return false;
        }
    }

    return true;
}

int perm[MAXN];
int cnt[MAXN][MAXK];

bool canPut(int node, int c)
{
    if (cnt[node][c] > d / k)
    {
        return false;
    }

    for (const int &u : g[node])
    {
        //if (node == 3) std::cout << "for: " << node << ' ' << u << ' ' << c << ' ' << col[u] << ' ' << cnt[u][c] << '\n';
        if (col[u] == c && cnt[u][c] == d / k)
        {
            return false;
        }
    }

    return true;
}

void put(int node, int c)
{
    col[node] = c;
    for (const int &u : g[node])
    {
        if (col[u] != 0) cnt[u][c]++;
    }
}

void solve()
{

    /*do
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            col[i] = rng() % k + 1;
        }
    } while (!check());*/

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return g[x].size() < g[y].size();
    });

    for (int idx = 1 ; idx <= n ; ++idx)
    {
        int node = perm[idx];
        std::fill(cnt[node] + 1, cnt[node] + 1 + k, 0);
        for (const int &u : g[node])
        {
            if (col[u] != 0)
            {
                cnt[node][col[u]]++;
            }
        }

        col[node] = 0;
        for (int i = 1 ; i <= k ; ++i)
        {
            if (canPut(node, i) && (col[node] == 0 || cnt[node][i] < cnt[node][col[node]]))
            {
                //std::cout << "can put: " << node << ' ' << i << '\n';
                col[node] = i;
            }
        }

        //std::cout << "put: " << node << ' ' << col[node] << '\n';
        put(node, col[node]);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << col[i] << ' ';
    }

    std::cout << '\n';
}

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        g[i].clear();
    }
}

void input()
{
    std::cin >> n >> m >> d >> k;
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIOI();
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        solve();
    }

    return 0;
}
