#include <iostream>
#include <stack>
#include <vector>
using namespace std;
const int MAXN = 2 * 1e5 + 1;
const int INF = 1e9 + 7;
vector<int> neighbours[MAXN][2];
int dist[MAXN][3];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 1; i <= m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        neighbours[u][t - 1].push_back(v);
        neighbours[v][t - 1].push_back(u);
    }
    for (int i = 1; i <= n; i++) {
        dist[i][0] = INF;
        dist[i][1] = INF;
        dist[i][2] = INF;
    }
    dist[1][0] = 0;
    dist[1][1] = 0;
    dist[1][2] = 0;
    stack< pair< pair<int, int>, pair<int, int> > > dep;
    dep.push({{0, 0}, {0, 1}});
    while (!dep.empty()) {
        int curr = dep.top().second.second;
        int len[3];
        len[0] = dep.top().first.first;
        len[1] = dep.top().first.second;
        len[2] = dep.top().second.first;
        dep.pop();
        if (len[0] >= dist[curr][0] && len[1] >= dist[curr][1] && len[2] >= dist[curr][2] && len[0] != 0) {
            continue;
        }
        for (int i = 0; i < 3; i++) {
            dist[curr][i] = min(dist[curr][i], len[i]);
            len[i] = dist[curr][i];
        }
        for (auto it : neighbours[curr][0]) {
            dep.push({{min(len[0] + 1, INF), min(len[1] + 1, INF)}, {min(len[2] + 1, INF), it}});
        }
        for (auto it : neighbours[curr][1]) {
            dep.push({{INF, min(len[0] + 1, INF)}, {min(len[1] + 1, INF), it}});
        }
    }
    int ans = min(dist[n][0], dist[n][1]);
    if (k == 2) {
        ans = min(ans, dist[n][2]);
    }
    if (ans >= INF) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
    return 0;
}
