#include <iostream>
#include <queue>
#include <vector>
using namespace std;
const int MAXN = 2 * 1e5 + 1;
const int INF = 1e9 + 7;
vector<int> neighbours[MAXN];
vector< pair<int, int> > edge;
int dist[MAXN][2];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 1; i <= m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        if (t == 1) {
            neighbours[u].push_back(v);
            neighbours[v].push_back(u);
        } else {
            edge.push_back({u, v});
        }
    }
    for (int i = 1; i <= n; i++) {
        dist[i][0] = INF;
        dist[i][1] = INF;
    }
    priority_queue< pair<int, int> > dep;

    dep.push({0, 1});
    while (!dep.empty()) {
        int curr = dep.top().second;
        int len = -dep.top().first;
        dep.pop();
        if (len >= dist[curr][0]) {
            continue;
        }
        dist[curr][0] = len;
        for (auto it : neighbours[curr]) {
            dep.push({-(len + 1), it});
        }
    }

    dep.push({0, n});
    while (!dep.empty()) {
        int curr = dep.top().second;
        int len = -dep.top().first;
        dep.pop();
        if (len >= dist[curr][1]) {
            continue;
        }
        dist[curr][1] = len;
        for (auto it : neighbours[curr]) {
            dep.push({-(len + 1), it});
        }
    }
    int ans = dist[n][0];
    for (auto it : edge) {
        int u = it.first;
        int v = it.second;
        ans = min(ans, min(dist[u][0] + dist[v][1], dist[v][0] + dist[u][1]) + 1);
    }
    if (ans >= INF) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
    return 0;
}

