#include <iostream>
#include <vector>
#include "segment.h"
using namespace std;
const long long INF = 2 * 1e9;
const int MAXN = 3 * 1e6 + 1;
int sparse[MAXN][25];
int lg[MAXN];
long long gcd(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
long long query(int l, int r) {
    int len = r - l + 1;
    int exp = lg[len];
    return gcd(sparse[l][exp], sparse[max(1, r - (1 << exp) + 1)][exp]);
}
long long max_segment(vector<int> A) {
    int n = A.size();
    lg[1] = 0;
    for (int i = 2; i <= n; i++) {
        if (i == (1 << (lg[i - 1] + 1))) {
            lg[i] = lg[i - 1] + 1;
        } else {
            lg[i] = lg[i - 1];
        }
    }
    for (int i = 1; i <= n; i++) {
        sparse[i][0] = A[i - 1];
    }
    for (int exp = 1; exp < 25; exp++) {
        for (int i = 1; i <= n; i++) {
            sparse[i][exp] = gcd(sparse[i][exp - 1], sparse[min(i + (1 << (exp - 1)), n)][exp - 1]);
        }
    }
    long long maxx = 1;

    for (int i = 1; i <= n; i++) {
        for (int j = i; j <= n; j++) {
            maxx = max(maxx, (j - i + 1) * query(i, j));
        }
    }

    return maxx;
}
//int main() {
//
//    return 0;
//}
