#include <iostream>
#include <vector>
#include "segment.h"
using namespace std;
const long long INF = 2 * 1e9;
const int MAXN = 3 * 1e6 + 1;
int sparse[MAXN][25];
int lg[MAXN];
long long gcd(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
long long query(int l, int r) {
    int len = r - l + 1;
    int exp = lg[len];
    return gcd(sparse[l][exp], sparse[max(1, r - (1 << exp) + 1)][exp]);
}
long long max_segment(vector<int> A) {
    int n = A.size();
    lg[1] = 0;
    for (int i = 2; i <= n; i++) {
        if (i == (1 << (lg[i - 1] + 1))) {
            lg[i] = lg[i - 1] + 1;
        } else {
            lg[i] = lg[i - 1];
        }
    }
    int maxx = 0;
    for (int i = 1; i <= n; i++) {
        sparse[i][0] = A[i - 1];
        maxx = max(maxx, sparse[i][0]);
    }
    for (int exp = 1; exp < 25; exp++) {
        for (int i = 1; i <= n; i++) {
            sparse[i][exp] = gcd(sparse[i][exp - 1], sparse[min(i + (1 << (exp - 1)), n)][exp - 1]);
        }
    }
    long long l = n;
    long long r = maxx * n;
    while (1) {
        if (l + 1 == r) {
            break;
        }
        long long mid = (l + r) / 2;
        bool done = false;
        for (int i = 1; i <= n && !done; i++) {
            int len = 1;
            int curr = sparse[i][0];
            while (i + len - 1 <= n) {
                if (curr * len >= mid) {
                    done = true;
                    break;
                } else {
                    len = mid / curr + (mid % curr != 0);
                    curr = query(i, min(i + len - 1, n));
                }
            }
        }
        if (done) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}
//int main() {
//
//    return 0;
//}

