#include <iostream>
#include <vector>
#include <stack>
#include "segment.h"
using namespace std;
const long long INF = 2 * 1e9;
const int MAXN = 3 * 1e6 + 1;
long long sparse[MAXN][25];
int lg[MAXN];
long long rig[MAXN], lef[MAXN];
long long gcd(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
long long query(int l, int r) {
    int len = r - l + 1;
    int exp = lg[len];
    return gcd(sparse[l][exp], sparse[max(1, r - (1 << exp) + 1)][exp]);
}
long long max_segment(vector<int> A) {
    long long n = A.size();
    lg[1] = 0;
    for (int i = 2; i <= n; i++) {
        if (i == (1 << (lg[i - 1] + 1))) {
            lg[i] = lg[i - 1] + 1;
        } else {
            lg[i] = lg[i - 1];
        }
    }
    long long maxx = n;
    for (int i = 1; i <= n; i++) {
        sparse[i][0] = A[i - 1];
        maxx = max(maxx, sparse[i][0]);
    }
    for (int exp = 1; exp < 25; exp++) {
        for (long long i = 1; i <= n; i++) {
            sparse[i][exp] = gcd(sparse[i][exp - 1], sparse[min(i + (1 << (exp - 1)), n)][exp - 1]);
        }
    }

    bool coprime = true;
    bool binary = true;
    for (int i = 1; i <= n; i++) {
        if (sparse[i][1] != 1) {
            coprime = false;
            break;
        }
    }
    for (int i = 1; i <= n && binary; i++) {
        int curr = sparse[i][0];
        while (curr > 1) {
            if (curr % 2 == 1) {
                binary = false;
                break;
            }
            curr /= 2;
        }
    }
    if (coprime) {
        return maxx;
    }
    if (binary) {
        stack<long long> dep;
        dep.push(0);
        for (int i = 1; i < n; i++) {
            while (!dep.empty() && A[i] < A[dep.top()]) {
                rig[dep.top()] = i;
                dep.pop();
            }
            dep.push(i);
        }
        while (!dep.empty()) {
            rig[dep.top()] = n;
            dep.pop();
        }

        dep.push(n - 1);
        for (int i = n - 2; i >= 0; i--) {
            while (!dep.empty() && A[i] < A[dep.top()]) {
                lef[dep.top()] = i;
                dep.pop();
            }
            dep.push(i);
        }
        while (!dep.empty()) {
            lef[dep.top()] = -1;
            dep.pop();
        }

        for (int i = 0; i < n; i++) {
            long long len = (rig[i] - 1) - (lef[i] + 1) + 1;
            maxx = max(maxx, A[i] * len);
        }
        return maxx;
    }


    long long l = n;
    long long r = maxx * n + 1;
    while (1) {
        if (l + 1 == r) {
            break;
        }
        long long mid = (l + r) / 2;
        bool done = false;
        for (int i = 1; i <= n && !done; i++) {
            long long len = 1;
            long long curr = sparse[i][0];
            while (i + len - 1 <= n) {
                if (curr * len >= mid) {
                    done = true;
                    break;
                } else {
                    len = mid / curr + (mid % curr != 0);
                    curr = query(i, min(i + len - 1, n));
                }
            }
        }
        if (done) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}
//int main() {
//
//    return 0;
//}

