#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
const int MAXN = 1e5 + 1;
const int MAXM = 2 * 1e5 + 1;
pair<int, int> edges[MAXM];
vector< pair<int, int> > neighbours[MAXN];
vector<int> diff[MAXN];
int color[MAXN];
void solve() {
    int n, m, d, k;
    cin >> n >> m >> d >> k;
    for (int i = 1; i <= m; i++) {
        cin >> edges[i].first >> edges[i].second;
        if (edges[i].first > edges[i].second) {
            swap(edges[i].first, edges[i].second);
        }
    }
    sort(edges + 1, edges + m + 1);
    edges[0] = {0, 0};
    int num = 1;
    for (int i = 2; i <= m; i++) {
        if (edges[i].first == edges[i - 1].first && edges[i].second == edges[i - 1].second) {
            num++;
        } else {
            neighbours[edges[i - 1].first].push_back({num, edges[i - 1].second});
            neighbours[edges[i - 1].second].push_back({num, edges[i - 1].first});
            num = 1;
        }
    }
    neighbours[edges[m].first].push_back({num, edges[m].second});
    neighbours[edges[m].second].push_back({num, edges[m].first});
    for (int i = 1; i <= n; i++) {
        color[i] = 0;
        sort(neighbours[i].begin(), neighbours[i].end());
        int num = 0;
        bool stop = false;
        for (int j = neighbours[i].size() - 1; j >= 0 && !stop; j--) {
            num += neighbours[i][j].first;
            diff[i].push_back(neighbours[i][j].second);
            if (num >= neighbours[i].size() - d / k) {
                stop = true;
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        vector<int> colors;
        for (auto it : diff[i]) {
            colors.push_back(color[it]);
        }
        sort(colors.begin(), colors.end());
        int trial = 1;
        for (int i = 0; i < colors.size(); i++) {
            if (trial == i) {
                trial++;
            }
            if (trial < i) {
                break;
            }
        }
        color[i] = trial;
    }
    for (int i = 1; i <= n; i++) {
        cout << color[i] << ' ';
    }
    cout << '\n';
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}

