#include "segment.h"
#include <iostream>
#include <vector>
using namespace std;
const int MAXN=3e6+10;
const int LOG=22;
int sp[LOG][MAXN];
int stepen[MAXN];
long long cur;
int n;
int gcd(int a, int b) {
    int r;
    while (b>0) {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}
int interval(int l, int r) {
    int st=stepen[r-l+1];
    return gcd(sp[st][l],sp[st][r-(1<<st)+1]);
}
int find_next(int beg, int i) {
    int l, r, mid;
    l=i+1; r=n-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (interval(beg,mid)==cur) l=mid+1;
        else r=mid-1;
    }
    return l-1;
}
long long max_segment(vector <int> a) {
    n=a.size();
    for (int i=0;i<n;i++) sp[0][i]=a[i];
    for (int i=1;(1<<i)<=n;i++) {
        for (int j=0;j+(1<<i)<=n;j++) {
            sp[i][j]=gcd(sp[i-1][j],sp[i-1][j+(1<<(i-1))]);
        }
    }
    int br=1;
    for (int i=1;i<=n;i++) {
        if ((1<<(br+1))<i) br++;
        stepen[i]=br;
    }
    long long ans=0, len;
    int gr;
    for (int i=0;i<n;i++) {
        cur=a[i];
        gr=find_next(i,i);
        while (gr<n) {
            len=gr-i+1;
            ans=max(ans,cur*len);
            if (gr==n-1) break;
            gr++;
            cur=interval(i,gr);
            gr=find_next(i,gr);
        }
    }
    return ans;
}
/*
int main () {
    cout << max_segment({2,2,1,4,4,8,2}) << endl;
    return 0;
}*/
