#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll Size=2e5+1;

ll start_dist[Size], end_dist[Size];
vector<ll> adj[Size];
vector<pair<ll,ll>> airplanes;
ll n,m,k;
bool visited[Size];

void reset_visited(){
    for(ll i=1;i<=n;i++){
        visited[i]=false;
    }
}

void bfs1(ll start_node){
    queue<ll> to_process;
    to_process.push(start_node);
    start_dist[1]=0;
    while(!to_process.empty()){
        ll curr_node=to_process.front();
        to_process.pop();
        visited[curr_node]=true;
        for(auto next_node:adj[curr_node]){
            if(!visited[next_node]){
                start_dist[next_node]=start_dist[curr_node]+1;
                to_process.push(next_node);
            }
        }
    }
}

void bfs2(ll start_node){
    queue<ll> to_process;
    end_dist[n]=0;
    to_process.push(start_node);
    while(!to_process.empty()){
        ll curr_node=to_process.front();
        to_process.pop();
        visited[curr_node]=true;
        for(auto next_node:adj[curr_node]){
            if(!visited[next_node]){
                end_dist[next_node]=end_dist[curr_node]+1;
                to_process.push(next_node);
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>m>>k;
    for(ll i=1;i<=n;i++){
        start_dist[i]=-1;
        end_dist[i]=-1;
    }
    for(ll i=0;i<m;i++){
        ll from,to,type;
        cin>>from>>to>>type;
        if(type==2){
            airplanes.push_back({from,to});
        }else{
            adj[from].push_back(to);
            adj[to].push_back(from);
        }
    }
    bfs1(1);
    reset_visited();
    bfs2(n);
    ll ans=1e18;
    for(ll i=1;i<=n;i++){
        if(start_dist[i]!=-1 and end_dist[i]!=-1)
            ans=min(ans,start_dist[i]+end_dist[i]);
    }
    for(auto curr_edge:airplanes){
        if(start_dist[curr_edge.first]!=-1 and end_dist[curr_edge.second]!=-1){
            ans=min(ans,start_dist[curr_edge.first]+end_dist[curr_edge.second]+1);
        }
        if(start_dist[curr_edge.second]!=-1 and end_dist[curr_edge.first]!=-1){
            ans=min(ans,start_dist[curr_edge.second]+end_dist[curr_edge.first]+1);
        }
    }
    /*
    for(ll i=1;i<=n;i++){
        cout<<start_dist[i]<<" ";
    }
    cout<<endl;
    for(ll i=1;i<=n;i++){
        cout<<end_dist[i]<<" ";
    }
    cout<<endl;
    */
    if(ans==1e18){
        cout<<-1<<endl;
        return 0;
    }
    cout<<ans<<endl;
    return 0;
}
