#include "segment.h"

typedef long long ll;

const ll Size=3e6+1;
vector<int> a;
ll left_id[Size],right_id[Size];
ll seg_tree[4*Size];

void build(ll l,ll r,ll i){
    if(l==r){
        seg_tree[i]=a[l];
    }else{
        ll mid=(l+r)/2;
        build(l,mid,i*2);
        build(mid+1,r,i*2+1);
        seg_tree[i]=__gcd(seg_tree[i*2],seg_tree[i*2+1]);
    }
}

ll query(ll l,ll r,ll tl,ll tr,ll i){
    if(tl>r or tr<l){
        return -1;
    }
    if(tl==l and tr==r){
        return seg_tree[i];
    }else{
        ll mid=(l+r)/2;
        ll n1=query(l,mid,tl,std::min(tr,mid),i*2);
        ll n2=query(mid+1,r,std::max(tl,mid+1),tr,i*2+1);
        if(n1==-1)
            return n2;
        if(n2==-1)
            return n1;
        return __gcd(n1,n2);
    }
}

ll max_segment(std::vector<int> A){
    ll n=A.size();
    for(ll i=0;i<n;i++){
        a.push_back(A[i]);
    }
    ll ans=0;
    build(0,n-1,1);
    for(ll i=0;i<n;i++){
        ans=std::max(ans,(ll)a[i]);
        for(ll j=i+1;j<n;j++){
            ll gcd=query(0,n-1,i,j,1);
            ans=std::max(ans,(j-i+1)*gcd);
        }
    }
    return ans;
}

