#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>

#include "segment.h"

using namespace std;

const int MAXN = 3e6 + 3;

int tree[4 * MAXN];

void build_tree(int ind, int tl, int tr, vector<int> &nums) {
    if (tl == tr) {
        tree[ind] = nums[tl];
        return;
    }

    int mid = (tl + tr) / 2;

    build_tree(2 * ind, tl, mid, nums);
    build_tree(2 * ind + 1, mid + 1, tr, nums);

    tree[ind] = __gcd(tree[2 * ind], tree[2 * ind + 1]);
}

int query(int ind, int tl, int tr, int targetL, int targetR) {
    if (tl > tr or targetL > tr or targetR < tl) {
        return 0;
    }

    if (targetL <= tl and tr <= targetR) {
        return tree[ind];
    }

    int mid = (tl + tr) / 2;

    int result = 0;

    if (targetL <= mid) {
        result = __gcd(result, query(2 * ind, tl, mid, targetL, targetR));
    }

    if (targetR >= mid + 1) {
        result = __gcd(result, query(2 * ind + 1, mid + 1, tr, targetL, targetR));
    }

    return result;
}

long long max_segment(vector<int> nums) {
    int n = (int) nums.size();

    build_tree(1, 0, n - 1, nums);

    long long result = n;
    int counter = 0;

    for (int i = 0; i < n; ++i) {
        if (i > 0 and nums[i] != nums[i - 1]) {
            counter = 0;
        }

        ++counter;

        result = max(result, 1ll * counter * nums[i]);
    }

    return result;
}

