#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>

#include "segment.h"

using namespace std;

const long long INF = 1e18;

const int MAXN = 3e6 + 3;

int tree[4 * MAXN];

void build_tree(int ind, int tl, int tr, vector<int> &nums) {
    if (tl == tr) {
        tree[ind] = nums[tl];
        return;
    }

    int mid = (tl + tr) / 2;

    build_tree(2 * ind, tl, mid, nums);
    build_tree(2 * ind + 1, mid + 1, tr, nums);

    tree[ind] = __gcd(tree[2 * ind], tree[2 * ind + 1]);
}

int query(int ind, int tl, int tr, int targetL, int targetR) {
    if (tl > tr or targetL > tr or targetR < tl) {
        return 0;
    }

    if (targetL <= tl and tr <= targetR) {
        return tree[ind];
    }

    int mid = (tl + tr) / 2;

    int result = 0;

    if (targetL <= mid) {
        result = __gcd(result, query(2 * ind, tl, mid, targetL, targetR));
    }

    if (targetR >= mid + 1) {
        result = __gcd(result, query(2 * ind + 1, mid + 1, tr, targetL, targetR));
    }

    return result;
}

long long max_segment(vector<int> nums) {
    int n = (int) nums.size();

    build_tree(1, 0, n - 1, nums);

    long long result = n;

    for (int l = 0; l < n; ++l) {
        long long previousValue = -1;

        for (int r = l; r < n; ++r) {
            int currentGcd = query(1, 0, n - 1, l, r);
            long long currentValue = 1ll * (r - l + 1) * currentGcd;

            result = max(result, currentValue);

            if (currentGcd == 1 or currentValue < previousValue) {
                break;
            }

            previousValue = currentValue;
        }
    }

    return result;
}

