#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

const int NO_COLOR = -1;

void solve() {
    int n, m, d, k;
    cin >> n >> m >> d >> k;

    int sameColorLimit = d / k;

    vector<vector<int>> graph(n);
    vector<int> inDegree(n);

    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;

        --from;
        --to;

        graph[from].push_back(to);
        graph[to].push_back(from);

        ++inDegree[from];
        ++inDegree[to];
    }

    vector<pair<int, int>> allNodeDegrees(n);

    for (int i = 0; i < n; ++i) {
        allNodeDegrees[i] = {inDegree[i], i};
    }

    sort(allNodeDegrees.begin(), allNodeDegrees.end());

    vector<int> colors(n, NO_COLOR);

    int currentColor = 0;
    for (int i = 0; i < n; ++i) {
        // cout << colors[i] << " ";

        cout << currentColor + 1 << " ";

        ++currentColor;

        if (currentColor >= k) {
            currentColor = 0;
        }
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;;

    for (int test = 0; test < tests; ++test) {
        solve();
    }

    return 0;
}
