#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int NO_COLOR = -1;

bool brute_force(int currentNode, int allColors, int sameColorLimit, vector<int> &colors, vector<vector<int>> &graph) {
    for (int newColor = 0; newColor < allColors; ++newColor) {
        int sameColorCounter = 0;

        for (int nextNode : graph[currentNode]) {
            if (colors[nextNode] == newColor) {
                ++sameColorCounter;
            }
        }

        if (sameColorCounter > sameColorLimit) {
            continue;
        }

        bool isGraphOk = true;
        colors[currentNode] = newColor;

        for (int nextNode : graph[currentNode]) {
            if (colors[nextNode] == NO_COLOR) {
                if (!brute_force(nextNode, allColors, sameColorLimit, colors, graph)) {
                    isGraphOk = false;
                    break;
                }
            }
        }

        if (isGraphOk) {
            return true;
        }

        colors[currentNode] = NO_COLOR;
    }

    return false;
}

void solve() {
    int n, m, d, k;
    cin >> n >> m >> d >> k;

    int sameColorLimit = d / k;

    vector<vector<int>> graph(n);

    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;

        --from;
        --to;

        graph[from].push_back(to);
        graph[to].push_back(from);
    }

    vector<int> colors(n, NO_COLOR);

    brute_force(0, k, sameColorLimit, colors, graph);

    for (int i = 0; i < n; ++i) {
        cout << colors[i] + 1 << " ";
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;;

    for (int test = 0; test < tests; ++test) {
        solve();
    }

    return 0;
}
