#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int NO_COLOR = -1;

bool brute_force(int currentNode, int allNodes, int allColors, int sameColorLimit, vector<int> &colors, vector<vector<int>> &graph) {
    if (currentNode == allNodes) {
        for (int i = 0; i < allNodes; ++i) {
            int sameColorCounter = 0;

            for (int j : graph[i]) {
                if (colors[i] != colors[j]) {
                    continue;
                }

                ++sameColorCounter;

                if (sameColorCounter > sameColorLimit) {
                    return false;
                }
            }
        }

        return true;
    }

    for (int newColor = 0; newColor < allColors; ++newColor) {
        colors[currentNode] = newColor;

        if (brute_force(currentNode + 1, allNodes, allColors, sameColorLimit, colors, graph)) {
            return true;
        }

        colors[currentNode] = NO_COLOR;
    }

    return false;
}

void solve() {
    int n, m, d, k;
    cin >> n >> m >> d >> k;

    int sameColorLimit = d / k;

    vector<vector<int>> graph(n);

    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;

        --from;
        --to;

        graph[from].push_back(to);
        graph[to].push_back(from);
    }

    vector<int> colors(n, NO_COLOR);

    brute_force(0, n, k, sameColorLimit, colors, graph);

    for (int i = 0; i < n; ++i) {
        cout << colors[i] + 1 << " ";
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;;

    for (int test = 0; test < tests; ++test) {
        solve();
    }

    return 0;
}
