#include <iostream>
#include <vector>
#include <queue>
#include <iomanip>
#include <climits>
#include <algorithm>
#define MAX_N 200005
using namespace std;

int n, m, k;
int dist[3][MAX_N];
int td;

vector<vector<pair<int, int>>> paths;

void dfs()
{
    fill_n(dist[0], MAX_N ,-MAX_N);
    fill_n(dist[1], MAX_N ,-MAX_N);
    priority_queue<pair<int, int>> qnoplane;
    priority_queue<pair<int, int>> qplane;
    qnoplane.push({0, 1});
    qplane.push({0, 1});
    pair<int, int> p, np;

    while(!qplane.empty() || !qnoplane.empty())
    {
        if(!qplane.empty())
        {
            p=qplane.top();
            qplane.pop();
            for(int i=0; i<paths[p.second].size(); i++)
            {
                if(paths[p.second][i].second==1)
                {
                    if(p.first==0)
                    {
                        td=-MAX_N;
                    }
                    else
                    {
                        td=p.first-1;
                    }
                    if(dist[1][paths[p.second][i].first]<td)
                    {
                        //cout << "***" << paths[p.second][i].first << " " << td << endl;
                        dist[1][paths[p.second][i].first]=td;
                        qplane.push({td, paths[p.second][i].first});
                    }

                }
            }
        }

        if(!qnoplane.empty())
        {
            np=qnoplane.top();
            qnoplane.pop();
            for(int i=0; i<paths[np.second].size(); i++)
            {
                if(paths[np.second][i].second==1)
                {
                    td=np.first-1;
                    if(dist[0][paths[np.second][i].first]<td)
                    {
                        //cout << "%%%" << paths[p.second][i].first << " " << td << endl;
                        dist[0][paths[np.second][i].first]=td;
                        qnoplane.push({td, paths[np.second][i].first});
                    }
                }
                if(paths[np.second][i].second==2)
                {
                    td=np.first-1;
                    //cout << "###" << paths[p.second][i].first << " " << td << endl;
                    if(dist[1][paths[np.second][i].first]<td)
                    {
                        dist[1][paths[np.second][i].first]=td;
                        qplane.push({td, paths[np.second][i].first});
                    }
                }
            }
        }
    }

}

void dfs_2()
{
    fill_n(dist[0], MAX_N ,-MAX_N);
    fill_n(dist[1], MAX_N ,-MAX_N);
    fill_n(dist[2], MAX_N ,-MAX_N);
    priority_queue<pair<int, int>> qnoplane;
    priority_queue<pair<int, int>> qplane;
    priority_queue<pair<int, int>> qtplane;
    qnoplane.push({0, 1});
    qplane.push({0, 1});
    pair<int, int> p, np, tp;

    while(!qplane.empty() || !qnoplane.empty() || !qtplane.empty())
    {
        if(!qplane.empty())
        {
            p=qplane.top();
            qplane.pop();
            for(int i=0; i<paths[p.second].size(); i++)
            {
                if(paths[p.second][i].second==1)
                {
                    if(p.first==0)
                    {
                        td=-MAX_N;
                    }
                    else
                    {
                        td=p.first-1;
                    }
                    if(dist[1][paths[p.second][i].first]<td)
                    {
                        //cout << "***" << paths[p.second][i].first << " " << td << endl;
                        dist[1][paths[p.second][i].first]=td;
                        qplane.push({td, paths[p.second][i].first});
                    }

                }
                if(paths[p.second][i].second==2)
                {
                    if(p.first==0)
                    {
                        td=-MAX_N;
                    }
                    else
                    {
                        td=p.first-1;
                    }
                    if(dist[2][paths[p.second][i].first]<td)
                    {
                        //cout << "***" << paths[p.second][i].first << " " << td << endl;
                        dist[2][paths[p.second][i].first]=td;
                        qplane.push({td, paths[p.second][i].first});
                    }

                }
            }
        }

        if(!qnoplane.empty())
        {
            np=qnoplane.top();
            qnoplane.pop();
            for(int i=0; i<paths[np.second].size(); i++)
            {
                if(paths[np.second][i].second==1)
                {
                    td=np.first-1;
                    if(dist[0][paths[np.second][i].first]<td)
                    {
                        //cout << "%%%" << paths[p.second][i].first << " " << td << endl;
                        dist[0][paths[np.second][i].first]=td;
                        qnoplane.push({td, paths[np.second][i].first});
                    }
                }
                if(paths[np.second][i].second==2)
                {
                    td=np.first-1;
                    //cout << "###" << paths[p.second][i].first << " " << td << endl;
                    if(dist[1][paths[np.second][i].first]<td)
                    {
                        dist[1][paths[np.second][i].first]=td;
                        qplane.push({td, paths[np.second][i].first});
                    }
                }
            }
        }

        if(!qtplane.empty())
        {
            tp=qtplane.top();
            qtplane.pop();
            for(int i=0; i<paths[tp.second].size(); i++)
            {
                if(paths[tp.second][i].second==1)
                {
                    if(tp.first==0)
                    {
                        td=-MAX_N;
                    }
                    else
                    {
                        td=tp.first-1;
                    }
                    if(dist[2][paths[tp.second][i].first]<td)
                    {
                        //cout << "***" << paths[tp.second][i].first << " " << td << endl;
                        dist[1][paths[tp.second][i].first]=td;
                        qplane.push({td, paths[tp.second][i].first});
                    }

                }
            }
        }
    }

}


int main()
{
    cin >> n >> m >> k;

    int t, a, b;

    paths.resize(n+1);

    for(int i=0; i<m; i++)
    {
        cin >> a >> b >> t;
        paths[a].push_back({b, t});
        paths[b].push_back({a, t});
    }

    /*for(int i=1; i<=n; i++)
    {
        cout << i << endl;
        for(int j=0; j<paths[i].size(); j++)
        {
            cout << paths[i][j].first << " ";
        }
        cout << endl;
    }*/

    if(k==1)
    {
        dfs();
        int ans=max(dist[0][n], dist[1][n]);
        if(ans<=-MAX_N)
        {
            cout << -1;
        }
        else
        {
            cout << ans*(-1);
        }
    }

    else if(k==2)
    {
        dfs_2();
        int ans=max(dist[0][n], dist[1][n]);
        ans=max(ans, dist[2][n]);
        if(ans<=-MAX_N)
        {
            cout << -1;
        }
        else
        {
            cout << ans*(-1);
        }
    }





    return 0;
}

