#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const int maxn = 3e6+2;
int n;
long long a[maxn];
struct tree
{
    long long minn;
    int pos;
};
tree t[4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].minn = a[r];
        t[i].pos = r;
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    if (t[2*i].minn <= t[2*i+1].minn)
    {
        t[i].minn = t[2*i].minn;
        t[i].pos = t[2*i].pos;
    }
    else
    {
        t[i].minn = t[2*i+1].minn;
        t[i].pos = t[2*i+1].pos;
    }
}

tree find_min(int i, int l, int r, int ql, int qr)
{
    if (r < ql || l > qr)
        return {LLONG_MAX, 0};
    if (l >= ql && r <= qr)
        return t[i];

    int mid = (l+r) >> 1;
    tree t1 = find_min(2*i, l, mid, ql, qr);
    tree t2 = find_min(2*i+1, mid+1, r, ql, qr);
    if (t1.minn <= t2.minn)
        return t1;
    return t2;
}

long long solve(int l, int r)
{
    if (r < l) return 0;
    long long len = (long long)(r-l+1);
    if (len == 2)
    {
        long long k = a[l];
        if (a[r] < k) k = a[r];
        long long ans1 = k * 2;
        long long ans2 = a[l] + a[r] - k;
        return (ans1 > ans2 ? ans1 : ans2);
    }
    if (len == 1) return a[r];

    tree e = find_min(1, 1, n, l, r);
    long long ans1 = solve(l, e.pos-1);
    long long ans2 = solve(e.pos+1, r);
    long long ans3 = len * e.minn;

    long long ans = (ans1 > ans2 ? ans1 : ans2);
    ans = (ans > ans3 ? ans : ans3);
    return ans;
}

long long max_segment(std::vector<int> A)
{
    n = (int)(A.size());
    int i;
    for (i=0; i<n; ++i)
        a[i+1] = (long long)(A[i]);
    make_tree(1, 1, n);

    return solve(1, n);
}