#include<bits/stdc++.h>
#define enbdl '\n'
#pragma optimize ("Ofast")
using namespace std;
const int maxn = 2e5 + 10, maxm = 6 * maxn;
struct edge{
    int to, next;
    bool type;
    edge(){
        to = -1;
        next = -1;
        type = false;
    }
    edge(int _to, int _next, bool _type){
        to = _to;
        next = _next;
        type = _type;
    }
};

int n, m, k;
unsigned int mincost = (1<<32) - 1;
edge e[maxm];
int head[maxn];
int useded[maxm];
int used[maxn];

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void add_edge(int from, int to, bool type){
    static int cnte = 0;
    e[cnte] = edge(to, head[from], type);
    head[from] = cnte;
    ++cnte;
}

void add_path(int from, int to, bool type){
    add_edge(from, to, type);
    add_edge(to, from, type);
}

void read(){
    memset(head, -1, sizeof(head));
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i){
        int from, to, type;
        cin >> from >> to >> type;
        add_path(from, to, (type + 1) % 2);
    }
}

void brute_BFS(){
    memset(used, 0, sizeof(used));
    used[1] = 1;
    queue<int> q;
    q.push(1);
    while(!q.empty()){
        int cur = q.front();
        q.pop();
        for (int i = head[cur]; i != -1; i = e[i].next){
            if (useded[i / 2]){
                if (!used[e[i].to]){
                    used[e[i].to] = used[cur] + 1;
                    q.push(e[i].to);
                }
            }
        }
    }
    if (used[n])
        mincost = ((unsigned int)(used[n] - 1) < mincost)? (used[n] - 1): mincost;
}

void check_perm(){
    int cntplanes = 0;
    for (int i = 0; i < m; ++i)
        if (useded[i] && e[i * 2].type)
            cntplanes++;
    //cout << "cntplanes: " << cntplanes << endl;
    if (cntplanes <= k)
        brute_BFS();
}

void permutations(int pos){
    if (pos == m){
        check_perm();
        return;
    }
    useded[pos] = 0;
    permutations(pos + 1);
    useded[pos] = 1;
    permutations(pos + 1);
}

void bruteforce(){
    memset(useded, 0, sizeof(useded));
    permutations(0);
    cout << (int) mincost << endl;
}

int main()
{
    read();
    /*for (int i = 1; i <= n; ++i){
        cout << "Node: " << i << "\n";
        for (int j = head[i]; j != -1; j = e[j].next){
            cout << "    " << e[j].to << " " << e[j].type << endl;
        }
    }*/
    bruteforce();
    return 0;
}
/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2
*/
/*
4 3 2
1 2 1
2 3 2
3 4 1
*/
/*
3 2 1
1 2 2
2 3 2
*/
