#include<bits/stdc++.h>
#define enbdl '\n'
#pragma optimize ("Ofast")
using namespace std;
const int maxn = 2e5 + 10, maxm = 6 * maxn;
struct edge{
    int to, next;
    bool type;
    edge(){
        to = -1;
        next = -1;
        type = false;
    }
    edge(int _to, int _next, bool _type){
        to = _to;
        next = _next;
        type = _type;
    }
};

int n, m, k;
int mincost = (1<<30);
edge e[maxm];
int head[maxn];
//int useded[maxm];
int used[2][maxn];
set<pair<int, int> > planes;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void add_edge(int from, int to, bool type){
    static int cnte = 0;
    e[cnte] = edge(to, head[from], type);
    head[from] = cnte;
    ++cnte;
}

void add_path(int from, int to, bool type){
    add_edge(from, to, type);
    add_edge(to, from, type);
}

void read(){
    memset(head, -1, sizeof(head));
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i){
        int from, to, type;
        cin >> from >> to >> type;
        add_path(from, to, (type + 1) % 2);
        if (type == 2)
            planes.insert({min(from, to), max(from, to)});
    }
}

void BFS(int beg, int idxu){
    //memset(used, 0, sizeof(used));
    used[idxu][beg] = 1;
    queue<int> q;
    q.push(beg);
    while(!q.empty()){
        int cur = q.front();
        q.pop();
        for (int i = head[cur]; i != -1; i = e[i].next){
            if (e[i].type == 0 && !used[idxu][e[i].to]){
                used[idxu][e[i].to] = used[idxu][cur] + 1;
                q.push(e[i].to);
            }
        }
    }
}

void search_pair(){
    if (used[0][n])
        mincost = used[0][n] - 1;
    for (int i = 1; i <= n; ++i)
        for (int j = i + 1; j <= n; ++j)
            if (planes.find({i, j}) != planes.end()){
                if (used[0][i] && used[1][j]){
                    int cost = used[0][i] + (used[1][j] - 1);///(used[0][i] - 1) + 1 (used[1][j] - 1)
                    mincost = (cost < mincost)? cost: mincost;
                }
                if (used[1][i] && used[0][j]){
                    int cost = used[1][i] + (used[0][j] - 1);///(used[1][i] - 1) + 1 (used[0][j] - 1)
                    mincost = (cost < mincost)? cost: mincost;
                }
            }
    mincost = (mincost == (1<<30))? -1: mincost;
    cout << mincost;
}

int main()
{
    read();
    /*for (int i = 1; i <= n; ++i){
        cout << "Node: " << i << "\n";
        for (int j = head[i]; j != -1; j = e[j].next){
            cout << "    " << e[j].to << " " << e[j].type << endl;
        }
    }*/
    //bruteforce();
    BFS(1, 0);
    BFS(n, 1);
    search_pair();
    return 0;
}
/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2
*/
/*
4 3 2
1 2 1
2 3 2
3 4 1
*/
/*
3 2 1
1 2 2
2 3 2
*/
