#include<bits/stdc++.h>
#define enbdl '\n'
#pragma optimize ("Ofast")
using namespace std;
const int maxn = 2e5 + 10, maxm = 6 * maxn;

struct edge{
    int to, next;
    bool type;
    edge(){
        to = -1;
        next = -1;
        type = false;
    }
    edge(int _to, int _next, bool _type){
        to = _to;
        next = _next;
        type = _type;
    }
};

struct Node{
    int to, cntplanes, cost;
    Node(){
        to = -1;
        cost = -1;
        cntplanes = -1;
    }
    Node(int _to){
        to = _to;
        cntplanes = 0;
        cost = 0;
    }
    Node(int _to, int _cntplanes, int _cost){
        to = _to;
        cntplanes = _cntplanes;
        cost = _cost;
    }
};

int n, m, k;
int mincost = (1<<30);
edge e[maxm];
int head[maxn];
//int useded[maxm];
int used[2][maxn];
//set<pair<int, int> > planes;
set<pair<int, int> > explored;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void add_edge(int from, int to, bool type){
    static int cnte = 0;
    e[cnte] = edge(to, head[from], type);
    head[from] = cnte;
    ++cnte;
}

void add_path(int from, int to, bool type){
    add_edge(from, to, type);
    add_edge(to, from, type);
}

void read(){
    memset(head, -1, sizeof(head));
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i){
        int from, to, type;
        cin >> from >> to >> type;
        add_path(from, to, (type + 1) % 2);
        /*if (type == 2)
            planes.insert({min(from, to), max(from, to)});*/
    }
}

void BFS(){
    queue<Node> q;
    q.push(Node(1, 0, 0));
    explored.insert({1, 0});
    while (!q.empty()){
        Node cur = q.front();
        q.pop();
        explored.insert({cur.to, cur.cntplanes});
        if (cur.to == n){
            cout << cur.cost << endl;
            exit(0);
        }
        for (int i = head[cur.to]; i != -1; i = e[i].next){
            Node next(e[i].to, cur.cntplanes, cur.cost + 1);
            if (e[i].type){
                if (cur.cntplanes == k)
                    continue;
                else next.cntplanes++;
            }
            if (explored.find({next.to, next.cntplanes}) == explored.end()){
                q.push(next);
                explored.insert({next.to, next.cntplanes});
            }
        }
    }
    cout << "-1\n";
}


int main()
{
    read();
    /*for (int i = 1; i <= n; ++i){
        cout << "Node: " << i << "\n";
        for (int j = head[i]; j != -1; j = e[j].next){
            cout << "    " << e[j].to << " " << e[j].type << endl;
        }
    }*/
    //bruteforce();
    BFS();
    return 0;
}
/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2
*/
/*
4 3 2
1 2 1
2 3 2
3 4 1
*/
/*
3 2 1
1 2 2
2 3 2
*/
