#include<bits/stdc++.h>
#include "segment.h"
#define endl '\n'
using namespace std;
const int maxn = 3e6 + 10;
int t[4*maxn];
int n;
long long ans = 0;

int gcd(int a, int b){
    if (a < b)swap(a, b);
    while (b){
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

void make_tree(int i, int l, int r,const vector<int> &a){
    if (l == r){
        t[i] = a[l - 1];
        return;
    }
    int mid = (l + r) / 2;
    make_tree(i * 2, l, mid, a);
    make_tree(i * 2 + 1, mid + 1, r, a);
    t[i] = __gcd(t[i * 2],  t[i * 2 + 1]);
}

int query(int i, int l, int r, int ql, int qr){
    //cout << "query: " << i << " " << l << " " << r << endl;
    if (l == ql && r == qr)
        return t[i];
    int mid = (l + r) / 2;
    if (qr <= mid)
        return query(i * 2, l, mid, ql, qr);
    if (ql > mid)
        return query(i * 2 + 1, mid + 1, r, ql, qr);
    return __gcd(query(i * 2, l, mid, ql, mid),
               query(i * 2 + 1, mid + 1, r, mid + 1, qr));
}

void tree_sol(const vector<int> &a){
    make_tree(1, 1, n, a);
    //cout << "here3\n";
    long long one, two, rez;
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; ++j){
            one = j - i + 1;
            two = query(1, 1, n, i, j);
            rez = one * two;
            //cout << "In for: " << i << " " << j << " " << one << " " << two << " " << rez << endl;
            ans = (ans < rez)? rez: ans;
        }
}

void platform_sol(const vector<int> &a){
    long long cnt_el = 1, el = a[0], rez;
    for (int i = 1; i < n; ++i){
        if (el == a[i])
            cnt_el++;
        else{
            rez = cnt_el * el;
            ans = (rez > ans)? rez: ans;
            cnt_el = 1;
            el = a[i];
        }
    }
    rez = cnt_el * el;
    ans = (rez > ans)? rez: ans;
}

bool check_two_powers(const vector<int> & a){
    unordered_set<int> powers;
    for (int i = 0; i <= 31; ++i)
        powers.insert((1<<i));
    for (int i = 0; i < n; ++i)
        if (powers.find(a[i])==powers.end())
            return false;
    return true;
}

void make_min_tree(int i, int l, int r, const vector<int> &a){
    if (l == r){
        t[i] = a[l - 1];
        return;
    }
    int mid = (l + r) / 2;
    make_min_tree(i * 2, l, mid, a);
    make_min_tree(i * 2 + 1, mid + 1, r, a);
    t[i] = min(t[i * 2], t[i * 2 + 1]);
}

int query_min_tree(int i, int l, int r, int ql, int qr){
    //cout << "l: " << l << " r: " << r << " ql: " << ql << " qr: " << qr << "\n";
    if (l == ql && r == qr)
        return t[i];
    int mid = (l + r) / 2;
    if (qr <= mid)
        return query_min_tree(i * 2, l, mid, ql, qr);
    if (ql > mid)
        return query_min_tree(i * 2 + 1, mid + 1, r, ql, qr);
    return min(query_min_tree(i * 2, l, mid, ql, mid),
               query_min_tree(i * 2 + 1, mid + 1, r, mid + 1, qr));
}

void two_powers_sol(const vector<int> &a){
    //cout << "here0\n";
    make_min_tree(1, 1, n, a);
    //cout << "here1\n";
    int l = 1, r = 1;
    long long opt1, opt2;
    ans = a[0];
    while (l < n){
        //cout << "l: " << l << " r: " << r << "\n";
        if (l != r)
            opt1 = ((long long)(r - l)) * ((long long)(query_min_tree(1, 1, n, l + 1, r)));
        else opt1 = 0;
        if (r < n - 1)
            opt2 = ((long long)(r - l + 2))*((long long)(query_min_tree(1, 1, n, l, r + 1)));
        else opt2 = 0;
        if (opt1 > opt2){
            l++;
            ans = (opt1 > ans)? opt1: ans;
        }
        else{
            r++;
            ans = (opt1 > ans)? opt1: ans;
        }
    }
}

long long max_segment(vector<int> A){
    //cout << "here -0\n";
    n = A.size();
    const vector<int> &a = A;
    //cout << "here -1\n";
    /*if (check_two_powers(a))
        two_powers_sol(a);*/
    //cout << "here -2\n";
    if (n <= 500)
        tree_sol(a);
    else if (check_two_powers(a))
        two_powers_sol(a);
    else platform_sol(a);
    return ans;
}
/*
7
6 5 10 15 2 4 8
*/
